// grab2bmp.c (C) Copyright  Bill Buckels 1994
// You are permitted to freely use the graphics files
// produced by GRAB2BMP with no preconditions.

// This program in whole or in part
// is the exclusive property of Bill Buckels.

// You are permitted to distribute the source
// and executable code as you see fit pursuant to
// the conditions stated below.

// You may not bundle this code in whole, in part,
// or in any form whatsoever with any other software without
// the express written permission of Bill Buckels.

// You may not charge any fee whatsoever for this software
// without the express written permission of Bill Buckels.

// The commercial distribution fee for GRAB2BMP is $1.00 per copy and
// is conditional on the purchase of a commercial distribution licence
// from Bill Buckels.

// A non-exclusive commercial distribution
// licence may be obtained by writing:

//                   Bill Buckels
//                   589 Oxford St.
//                   Winnipeg, Manitoba, Canada
//                   R3M 3J2

// An application fee of $10.00 and your return address
// must accompany your application.

// A conditional licencing agreement will be forwarded by return mail
// and must be in your possession prior to any commercial distribution.

// This licence is required by all commercial software authors including
// Shareware Authors prior to including GRAB2BMP with a Software Package.

// WAIVER OF LIABILITY: Bill Buckels is not liable in any way whatsoever
// for damage resulting from the use of GRAB2BMP. All reasonable precautions
// Have been taken for exception processing and conformance, but with any
// number of possible system configurations it is also possible that an
// unrecoverable error may occur.

// If you can't abide by the above stated condition don't use this program.

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <dos.h>

char RAMFONT[256][16]={
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7E, 0x81, 0xA5, 0x81, 0x81, 0xBD, 
0x99, 0x81, 0x81, 0x7E, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xFE, 0xFE, 0xD6, 0xFE, 0xFE, 
0xBA, 0xC6, 0xFE, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x6C, 0xEE, 0xFE, 0xFE, 0xFE, 
0xFE, 0x7C, 0x38, 0x10, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x10, 0x38, 0x7C, 0xFE, 0x7C, 
0x38, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x10, 0x38, 0x38, 0x10, 0x6C, 
0xEE, 0x6C, 0x10, 0x38, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x10, 0x38, 0x7C, 0x7C, 0xFE, 0xFE, 
0xFE, 0x6C, 0x10, 0x38, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x3C, 0x3C, 
0x3C, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE7, 0xC3, 0xC3, 
0xC3, 0xE7, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
0x00, 0x00, 0x00, 0x00, 0x18, 0x3C, 0x66, 0x66, 
0x66, 0x3C, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x1E, 0x0E, 0x1E, 0x36, 0x78, 0xCC, 
0xCC, 0xCC, 0xCC, 0x78, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x3C, 0x66, 0x66, 0x66, 0x3C, 0x18, 
0x7E, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x3E, 0x36, 0x3E, 0x36, 0x36, 0x76, 
0xF6, 0x66, 0x0E, 0x1E, 0x0C, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x18, 0xDB, 0x7E, 0x3C, 0x66, 0x66, 
0x3C, 0x7E, 0xDB, 0x18, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x80, 0xE0, 0xF0, 0xFC, 0xFE, 
0xFC, 0xF0, 0xE0, 0x80, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x02, 0x0E, 0x3E, 0x7E, 0xFE, 
0x7E, 0x3E, 0x0E, 0x02, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x18, 0x3C, 0x7E, 0x18, 0x18, 0x18, 
0x18, 0x7E, 0x3C, 0x18, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 
0x66, 0x00, 0x66, 0x66, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7F, 0xDB, 0xDB, 0xDB, 0xDB, 0x7B, 
0x1B, 0x1B, 0x1B, 0x1B, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0xC6, 0x60, 0x7C, 0xF6, 
0xDE, 0x7C, 0x0C, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0xFE, 0xFE, 0xFE, 0xFE, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x18, 0x3C, 0x7E, 0x18, 0x18, 0x18, 
0x7E, 0x3C, 0x18, 0x7E, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x18, 0x3C, 0x7E, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x7E, 0x3C, 0x18, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x0E, 0xFF, 
0x0E, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x70, 0xFE, 
0x70, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xC0, 
0xC0, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x24, 0x66, 0xFF, 
0x66, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x10, 0x38, 0x38, 0x38, 0x7C, 
0x7C, 0xFE, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0xFE, 0xFE, 0x7C, 0x7C, 0x7C, 
0x38, 0x38, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x18, 0x3C, 0x3C, 0x3C, 0x3C, 0x18, 
0x18, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x36, 0x36, 0x36, 0x36, 0x14, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x6C, 0x6C, 0x6C, 0xFE, 0x6C, 0x6C, 
0xFE, 0x6C, 0x6C, 0x6C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x18, 0x18, 0x7C, 0xC6, 0xC0, 0x78, 
0x3C, 0x06, 0xC6, 0x7C, 0x18, 0x18, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x62, 0x66, 0x0C, 
0x18, 0x30, 0x66, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x38, 0x6C, 0x38, 0x30, 0x76, 0x7E, 
0xCC, 0xCC, 0xCC, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x0C, 0x0C, 0x0C, 0x18, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x0C, 0x18, 0x30, 0x30, 0x30, 0x30, 
0x30, 0x30, 0x18, 0x0C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x30, 0x18, 0x0C, 0x0C, 0x0C, 0x0C, 
0x0C, 0x0C, 0x18, 0x30, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x6C, 0x38, 0xFE, 
0x38, 0x6C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x7E, 
0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x0C, 0x0C, 0x0C, 0x18, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x02, 0x06, 0x0C, 0x18, 
0x30, 0x60, 0xC0, 0x80, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0xC6, 0xCE, 0xDE, 0xF6, 
0xE6, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x18, 0x78, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x7E, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0xC6, 0x06, 0x0C, 0x18, 
0x30, 0x60, 0xC6, 0xFE, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0x06, 0x06, 0x3C, 0x06, 
0x06, 0x06, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x0C, 0x1C, 0x3C, 0x6C, 0xCC, 0xCC, 
0xFE, 0x0C, 0x0C, 0x1E, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xFE, 0xC0, 0xC0, 0xC0, 0xFC, 0x06, 
0x06, 0x06, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0xC0, 0xC0, 0xFC, 0xC6, 
0xC6, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xFE, 0xC6, 0x06, 0x0C, 0x18, 0x30, 
0x30, 0x30, 0x30, 0x30, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0xC6, 0xC6, 0x7C, 0xC6, 
0xC6, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0xC6, 0xC6, 0xC6, 0x7E, 
0x06, 0x06, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x0C, 0x00, 
0x00, 0x0C, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x0C, 0x0C, 0x00, 
0x00, 0x0C, 0x0C, 0x0C, 0x18, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x0C, 0x18, 0x30, 0x60, 0xC0, 
0x60, 0x30, 0x18, 0x0C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x00, 
0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x60, 0x30, 0x18, 0x0C, 0x06, 
0x0C, 0x18, 0x30, 0x60, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0xC6, 0x0C, 0x18, 0x18, 
0x18, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0xC6, 0xC6, 0xDE, 0xDE, 
0xDE, 0xDC, 0xC0, 0x7E, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x38, 0x6C, 0xC6, 0xC6, 0xC6, 0xFE, 
0xC6, 0xC6, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xFC, 0x66, 0x66, 0x66, 0x7C, 0x66, 
0x66, 0x66, 0x66, 0xFC, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x3C, 0x66, 0xC2, 0xC0, 0xC0, 0xC0, 
0xC0, 0xC2, 0x66, 0x3C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xF8, 0x6C, 0x66, 0x66, 0x66, 0x66, 
0x66, 0x66, 0x6C, 0xF8, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xFE, 0x66, 0x60, 0x64, 0x7C, 0x64, 
0x60, 0x60, 0x66, 0xFE, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xFE, 0x66, 0x60, 0x64, 0x7C, 0x64, 
0x60, 0x60, 0x60, 0xF0, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0xC6, 0xC0, 0xC0, 0xC0, 
0xCE, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xC6, 0xC6, 0xC6, 0xC6, 0xFE, 0xC6, 
0xC6, 0xC6, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x3C, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x3C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x3C, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x18, 0xD8, 0xD8, 0x70, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xC6, 0xC6, 0xCC, 0xD8, 0xF0, 0xF0, 
0xD8, 0xCC, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xF0, 0x60, 0x60, 0x60, 0x60, 0x60, 
0x60, 0x62, 0x66, 0xFE, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xC6, 0xC6, 0xEE, 0xEE, 0xFE, 0xD6, 
0xD6, 0xD6, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xC6, 0xC6, 0xE6, 0xE6, 0xF6, 0xDE, 
0xCE, 0xCE, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 
0xC6, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xFC, 0x66, 0x66, 0x66, 0x66, 0x7C, 
0x60, 0x60, 0x60, 0xF0, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 
0xC6, 0xD6, 0xD6, 0x7C, 0x06, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xFC, 0x66, 0x66, 0x66, 0x7C, 0x78, 
0x6C, 0x66, 0x66, 0xE6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0xC0, 0xC0, 0x70, 0x1C, 
0x06, 0x06, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7E, 0x5A, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x3C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 
0xC6, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 
0xC6, 0x6C, 0x38, 0x10, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xC6, 0xC6, 0xC6, 0xD6, 0xD6, 0xD6, 
0xFE, 0xEE, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xC6, 0xC6, 0xC6, 0x6C, 0x38, 0x38, 
0x6C, 0xC6, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x3C, 
0x18, 0x18, 0x18, 0x3C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xFE, 0xC6, 0x86, 0x0C, 0x18, 0x30, 
0x60, 0xC2, 0xC6, 0xFE, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0x60, 0x60, 0x60, 0x60, 0x60, 
0x60, 0x60, 0x60, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x80, 0xC0, 0x60, 0x30, 
0x18, 0x0C, 0x06, 0x02, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0x0C, 0x0C, 0x0C, 0x0C, 0x0C, 
0x0C, 0x0C, 0x0C, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x10, 0x38, 0x6C, 0xC6, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 
0x00, 0x18, 0x18, 0x18, 0x0C, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x0C, 0x7C, 
0xCC, 0xCC, 0xDC, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xE0, 0x60, 0x60, 0x7C, 0x66, 0x66, 
0x66, 0x66, 0x66, 0xFC, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x7C, 0xC6, 0xC0, 
0xC0, 0xC0, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x1C, 0x0C, 0x0C, 0x7C, 0xCC, 0xCC, 
0xCC, 0xCC, 0xCC, 0x7E, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x7C, 0xC6, 0xC6, 
0xFE, 0xC0, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x1C, 0x36, 0x30, 0x30, 0xFC, 0x30, 
0x30, 0x30, 0x30, 0x78, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0xCE, 0xC6, 
0xC6, 0xCE, 0x76, 0x06, 0xC6, 0x7C, 0x00, 0x00, 
0x00, 0x00, 0xE0, 0x60, 0x60, 0x7C, 0x66, 0x66, 
0x66, 0x66, 0x66, 0xE6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x18, 0x18, 0x00, 0x38, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x3C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x0C, 0x0C, 0x00, 0x1C, 0x0C, 0x0C, 
0x0C, 0x0C, 0x0C, 0xCC, 0xCC, 0x78, 0x00, 0x00, 
0x00, 0x00, 0xE0, 0x60, 0x60, 0x66, 0x66, 0x6C, 
0x78, 0x6C, 0x66, 0xE6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x1C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x6C, 0xFE, 0xD6, 
0xD6, 0xC6, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xDC, 0x66, 0x66, 
0x66, 0x66, 0x66, 0x66, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x7C, 0xC6, 0xC6, 
0xC6, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xDC, 0x66, 0x66, 
0x66, 0x66, 0x7C, 0x60, 0x60, 0xF0, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0xCC, 0xCC, 
0xCC, 0xCC, 0x7C, 0x0C, 0x0C, 0x1E, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xDC, 0x66, 0x60, 
0x60, 0x60, 0x60, 0xF0, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x7C, 0xC6, 0xC0, 
0x7C, 0x06, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x30, 0x30, 0x30, 0xFC, 0x30, 0x30, 
0x30, 0x30, 0x36, 0x1C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xCC, 0xCC, 0xCC, 
0xCC, 0xCC, 0xCC, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xC6, 0xC6, 0xC6, 
0xC6, 0x6C, 0x38, 0x10, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xC6, 0xC6, 0xD6, 
0xD6, 0xD6, 0xFE, 0x6C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xC6, 0xC6, 0x6C, 
0x38, 0x6C, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xC6, 0xC6, 0xC6, 
0xC6, 0xCE, 0x76, 0x06, 0xC6, 0x7C, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x86, 0x0C, 
0x18, 0x30, 0x62, 0xFE, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x0E, 0x18, 0x18, 0x18, 0x70, 0x18, 
0x18, 0x18, 0x18, 0x0E, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x00, 0x18, 
0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x70, 0x18, 0x18, 0x18, 0x0E, 0x18, 
0x18, 0x18, 0x18, 0x70, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x76, 0xDC, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x38, 0x38, 
0x6C, 0x6C, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x3C, 0x66, 0xC0, 0xC0, 0xC0, 0xC6, 
0x66, 0x3C, 0x18, 0x0C, 0xCC, 0x38, 0x00, 0x00, 
0x00, 0x00, 0xC6, 0x00, 0x00, 0xC6, 0xC6, 0xC6, 
0xC6, 0xC6, 0xCE, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x0C, 0x18, 0x30, 0x00, 0x7C, 0xC6, 0xC6, 
0xFE, 0xC0, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x30, 0x78, 0xCC, 0x00, 0x78, 0x0C, 0x7C, 
0xCC, 0xCC, 0xDC, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xCC, 0x00, 0x00, 0x78, 0x0C, 0x7C, 
0xCC, 0xCC, 0xDC, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x60, 0x30, 0x18, 0x00, 0x78, 0x0C, 0x7C, 
0xCC, 0xCC, 0xDC, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x38, 0x6C, 0x38, 0x00, 0x78, 0x0C, 0x7C, 
0xCC, 0xCC, 0xDC, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x7C, 0xC6, 0xC0, 0xC0, 
0xC6, 0x7C, 0x18, 0x0C, 0x6C, 0x38, 0x00, 0x00, 
0x00, 0x30, 0x78, 0xCC, 0x00, 0x7C, 0xC6, 0xC6, 
0xFE, 0xC0, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xCC, 0x00, 0x00, 0x7C, 0xC6, 0xC6, 
0xFE, 0xC0, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x30, 0x18, 0x0C, 0x00, 0x7C, 0xC6, 0xC6, 
0xFE, 0xC0, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x66, 0x00, 0x00, 0x38, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x3C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x18, 0x3C, 0x66, 0x00, 0x38, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x3C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x60, 0x30, 0x18, 0x00, 0x38, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x3C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0xC6, 0x00, 0x38, 0x6C, 0xC6, 0xC6, 0xC6, 
0xFE, 0xC6, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x38, 0x6C, 0x38, 0x00, 0x38, 0x6C, 0xC6, 0xC6, 
0xFE, 0xC6, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x0C, 0x18, 0x30, 0x00, 0xFE, 0x60, 0x60, 0x7C, 
0x60, 0x60, 0x60, 0xFE, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x66, 0xDB, 0x1B, 0x7F, 
0xD8, 0xD8, 0xDF, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7E, 0xD8, 0xD8, 0xD8, 0xD8, 0xFE, 
0xD8, 0xD8, 0xD8, 0xDE, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x30, 0x78, 0xCC, 0x00, 0x7C, 0xC6, 0xC6, 
0xC6, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xC6, 0x00, 0x00, 0x7C, 0xC6, 0xC6, 
0xC6, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x30, 0x18, 0x0C, 0x00, 0x7C, 0xC6, 0xC6, 
0xC6, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x30, 0x78, 0xCC, 0x00, 0xC6, 0xC6, 0xC6, 
0xC6, 0xC6, 0xCE, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x60, 0x30, 0x18, 0x00, 0xC6, 0xC6, 0xC6, 
0xC6, 0xC6, 0xCE, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0xC6, 0x00, 0x00, 0xC6, 0xC6, 0xC6, 0xC6, 
0xCE, 0x76, 0x06, 0x06, 0xC6, 0x7C, 0x00, 0x00, 
0x00, 0xC6, 0x00, 0x7C, 0xC6, 0xC6, 0xC6, 0xC6, 
0xC6, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0xC6, 0x00, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 
0xC6, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x18, 0x18, 0x7C, 0xC6, 0xC0, 0xC0, 
0xC6, 0x7C, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x38, 0x6C, 0x60, 0x60, 0xF0, 0x60, 0x60, 
0x60, 0x66, 0xF6, 0x6C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x66, 0x66, 0x66, 0x66, 0x3C, 0x18, 0x7E, 
0x18, 0x3C, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 
0x00, 0xFC, 0xC6, 0xC6, 0xFC, 0xC0, 0xCC, 0xDE, 
0xCC, 0xCC, 0xCC, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x0E, 0x1B, 0x18, 0x18, 0x18, 0x7E, 0x18, 
0x18, 0x18, 0x18, 0x18, 0xD8, 0x70, 0x00, 0x00, 
0x00, 0x0C, 0x18, 0x30, 0x00, 0x78, 0x0C, 0x7C, 
0xCC, 0xCC, 0xDC, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x0C, 0x18, 0x30, 0x00, 0x38, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x3C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x0C, 0x18, 0x30, 0x00, 0x7C, 0xC6, 0xC6, 
0xC6, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x18, 0x30, 0x60, 0x00, 0xCC, 0xCC, 0xCC, 
0xCC, 0xCC, 0xDC, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x76, 0xDC, 0x00, 0xBC, 0x66, 0x66, 
0x66, 0x66, 0x66, 0xE6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x76, 0xDC, 0x00, 0xC6, 0xC6, 0xE6, 0xF6, 
0xDE, 0xCE, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x3C, 0x6C, 0x6C, 0x3E, 0x00, 0x7E, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x38, 0x6C, 0x6C, 0x38, 0x00, 0x7C, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x30, 0x30, 0x00, 0x30, 0x30, 0x30, 
0x60, 0xC6, 0xC6, 0x7C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 
0x60, 0x60, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 
0x06, 0x06, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x60, 0x60, 0x62, 0x66, 0x6C, 0x18, 0x30, 
0x60, 0xDC, 0x36, 0x0C, 0x18, 0x3E, 0x00, 0x00, 
0x00, 0x60, 0x60, 0x62, 0x66, 0x6C, 0x18, 0x36, 
0x6E, 0xDE, 0x36, 0x7E, 0x06, 0x06, 0x00, 0x00, 
0x00, 0x00, 0x18, 0x18, 0x00, 0x18, 0x18, 0x3C, 
0x3C, 0x3C, 0x3C, 0x18, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x6C, 0xD8, 
0x6C, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xD8, 0x6C, 0x36, 
0x6C, 0xD8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x11, 0x44, 0x11, 0x44, 0x11, 0x44, 0x11, 0x44, 
0x11, 0x44, 0x11, 0x44, 0x11, 0x44, 0x11, 0x44, 
0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, 
0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55, 
0xDD, 0x77, 0xDD, 0x77, 0xDD, 0x77, 0xDD, 0x77, 
0xDD, 0x77, 0xDD, 0x77, 0xDD, 0x77, 0xDD, 0x77, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0xF8, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x18, 0x18, 0xF8, 0x18, 0xF8, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0xF6, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0x18, 0xF8, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x36, 0x36, 0x36, 0x36, 0x36, 0xF6, 0x06, 0xF6, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x06, 0xF6, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x36, 0x36, 0x36, 0x36, 0x36, 0xF6, 0x06, 0xFE, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0xFE, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x18, 0x18, 0x18, 0x18, 0x18, 0xF8, 0x18, 0xF8, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x1F, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0xFF, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x1F, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0xFF, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x1F, 0x18, 0x1F, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x37, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x37, 0x30, 0x3F, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x30, 0x37, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x36, 0x36, 0x36, 0x36, 0x36, 0xF7, 0x00, 0xFF, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xF7, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x37, 0x30, 0x37, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x36, 0x36, 0x36, 0x36, 0x36, 0xF7, 0x00, 0xF7, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x18, 0x18, 0x18, 0x18, 0x18, 0xFF, 0x00, 0xFF, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0xFF, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0xFF, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x3F, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x1F, 0x18, 0x1F, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x18, 0x1F, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0xFF, 
0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 0x36, 
0x18, 0x18, 0x18, 0x18, 0x18, 0xFF, 0x18, 0xFF, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0xF8, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 
0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 0xF0, 
0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 
0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 0x0F, 
0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x76, 0xDC, 0xD8, 0xD8, 
0xD8, 0xD8, 0xDC, 0x76, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x78, 0xCC, 0xD8, 0xFC, 
0xC6, 0xC6, 0xE6, 0xDC, 0xC0, 0xC0, 0x00, 0x00, 
0x00, 0x00, 0xFE, 0x66, 0x62, 0x60, 0x60, 0x60, 
0x60, 0x60, 0x60, 0x60, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x6C, 0x6C, 
0x6C, 0x6C, 0x6C, 0x6C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xFE, 0xC6, 0x62, 0x30, 0x18, 0x18, 
0x30, 0x62, 0xC6, 0xFE, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0xD8, 0xCC, 
0xCC, 0xCC, 0xD8, 0x70, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 
0x66, 0x7C, 0x60, 0xC0, 0x80, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0xDC, 0x18, 
0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xFE, 0x38, 0x38, 0x6C, 0xC6, 0xC6, 
0x6C, 0x38, 0x38, 0xFE, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x38, 0x6C, 0xC6, 0xC6, 0xFE, 
0xC6, 0xC6, 0x6C, 0x38, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x38, 0x6C, 0xC6, 0xC6, 0xC6, 0xC6, 
0x6C, 0x6C, 0x6C, 0xEE, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x3E, 0x60, 0x60, 0x3C, 0x66, 0xC6, 
0xC6, 0xC6, 0xCC, 0x78, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0xDB, 0xDB, 
0xDB, 0x7E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x02, 0x06, 0x7C, 0xCE, 0xDE, 0xF6, 
0xF6, 0x7C, 0x60, 0xC0, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x1C, 0x30, 0x60, 0x60, 0x7C, 
0x60, 0x60, 0x30, 0x1C, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x7C, 0xC6, 0xC6, 0xC6, 0xC6, 0xC6, 
0xC6, 0xC6, 0xC6, 0xC6, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0xFE, 0x00, 0x00, 0xFE, 
0x00, 0x00, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x7E, 0x18, 
0x18, 0x00, 0x00, 0x7E, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x30, 0x18, 0x0C, 0x06, 0x0C, 0x18, 
0x30, 0x00, 0x00, 0x7E, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x0C, 0x18, 0x30, 0x60, 0x30, 0x18, 
0x0C, 0x00, 0x00, 0x7E, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x0C, 0x1E, 0x1A, 0x18, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 
0x18, 0x18, 0x58, 0x78, 0x30, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x7E, 
0x00, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x76, 0xDC, 
0x00, 0x76, 0xDC, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x78, 0xCC, 0xCC, 0x78, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 
0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x1F, 0x18, 0x18, 0x18, 0x18, 0x18, 
0xD8, 0xD8, 0x78, 0x38, 0x18, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xD8, 0x6C, 0x6C, 0x6C, 0x6C, 0x6C, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x70, 0xD8, 0x18, 0x30, 0x60, 0xF8, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x7E, 0x7E, 0x7E, 
0x7E, 0x7E, 0x7E, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

unsigned int hres=640, vres=475;

#define UNSUPPORTED 0
#define BSVFILE     1
#define COMFILE     2

// Windows Bitmap Header structures
typedef struct tagRGBQUAD
{
    unsigned char    rgbBlue;
    unsigned char    rgbGreen;
    unsigned char    rgbRed;
    unsigned char    rgbReserved;
} RGBQUAD;

typedef struct tagBITMAPINFOHEADER
{
    unsigned long   biSize;
    unsigned long   biWidth;
    unsigned long   biHeight;
    unsigned        biPlanes;
    unsigned        biBitCount;
    unsigned long   biCompression;
    unsigned long   biSizeImage;
    unsigned long   biXPelsPerMeter;
    unsigned long   biYPelsPerMeter;
    unsigned long   biClrUsed;
    unsigned long   biClrImportant;
} BITMAPINFOHEADER;

typedef struct tagBITMAPINFO
{
    BITMAPINFOHEADER bmiHeader;
    RGBQUAD          bmiColors[16];
} BITMAPINFO;

typedef struct tagBITMAPFILEHEADER
{
    unsigned        bfType;
    unsigned long   bfSize;
    unsigned        bfReserved1;
    unsigned        bfReserved2;
    unsigned long   bfOffBits;
} BITMAPFILEHEADER;

// write the header for a 16 color BMP
void bmpheader(FILE *bmpfile)
{
    BITMAPFILEHEADER BitMapFileHeader;
    BITMAPINFO       bmp;
    unsigned char vgapalette[]={
        0x00, 0x00, 0x00,
        0x00, 0x00, 0xAA,
        0x00, 0xAA, 0x00,
        0x00, 0xAA, 0xAA,
        0xAA, 0x00, 0x00,
        0xAA, 0x00, 0xAA,
        0xAA, 0xAA, 0x00,
        0xAA, 0xAA, 0xAA,
        0x55, 0x55, 0x55,
        0x55, 0x55, 0xFF,
        0x55, 0xFF, 0x55,
        0x55, 0xFF, 0xFF,
        0xFF, 0x55, 0x55,
        0xFF, 0x55, 0xFF,
        0xFF, 0xFF, 0x55,
        0xFF, 0xFF, 0xFF};

    unsigned char *ptr;
    unsigned long seeksize = 320L;
    int i, j;

    seeksize *= vres;

    // Create a simple non-compressed 16 color planar bit-map.
    // Some of this stuff does not get used and is typically set to 0

    memset((char *)&BitMapFileHeader.bfType,0,sizeof(BITMAPFILEHEADER));
    memset((char *)&bmp.bmiHeader.biSize,0,sizeof(BITMAPINFO));

    // 1. Set the defaults for the file header.
    ptr=(char *)&BitMapFileHeader.bfType;
    ptr[0] = 'B';                            // signature = BM
    ptr[1] = 'M';
    BitMapFileHeader.bfSize =  seeksize + 118L;

    // File Size + Header
    BitMapFileHeader.bfOffBits=118L;         // standard 16 color header
                                             // offset to bitmap data
    // 2. Set the defaults for the Info Header

    bmp.bmiHeader.biSize          = 40L;         // info header size
    bmp.bmiHeader.biWidth         = (long)hres;  // pixels
    bmp.bmiHeader.biHeight        = (long)vres;  // rasters
    bmp.bmiHeader.biPlanes        = 1;           // device planes (always 1)
    bmp.bmiHeader.biBitCount      = 4;           // bits per pixel = 4
    bmp.bmiHeader.biSizeImage     = seeksize;

    // 3. Set-up a standard 16 color palette
    j=0;
    for(i=0;i<16;i++)
        {
        bmp.bmiColors[i].rgbRed       = vgapalette[j++];
        bmp.bmiColors[i].rgbGreen     = vgapalette[j++];
        bmp.bmiColors[i].rgbBlue      = vgapalette[j++];
        bmp.bmiColors[0].rgbReserved  = 0;
        }

    // 4. Write the header
    fwrite((char *)&BitMapFileHeader.bfType,
                   sizeof(BITMAPFILEHEADER),1,bmpfile);
    fwrite((char *)&bmp.bmiHeader.biSize,
                   sizeof(BITMAPINFO),1,bmpfile);
}


// convert 4 planar scanlines of a depth of 1 bit
// to a windows bitmap planar nibble raster
void bits2nibbles(char *ptr)
{
    unsigned char highnib[320],lownib[320];
    int i,j,x,planeoffset;
    unsigned char shiftbit;
    unsigned char temp;

    // clear the accumulators
    memset(highnib,0,320);
    memset(lownib,0,320);

    x=0;
    shiftbit = 1;
    for(i=0;i<4;i++)       // 4 bit planes
    {
      planeoffset=0;
      for(j=0;j<80;j++)   // make bits into nibbles
      {
        temp=ptr[x];
        // put them into the correct plane
        if(temp&0x80)highnib[planeoffset] |= shiftbit;
        if(temp&0x40)lownib[planeoffset]  |= shiftbit; planeoffset++;

        if(temp&0x20)highnib[planeoffset] |= shiftbit;
        if(temp&0x10)lownib[planeoffset]  |= shiftbit; planeoffset++;

        if(temp&0x08)highnib[planeoffset] |= shiftbit;
        if(temp&0x04)lownib[planeoffset]  |= shiftbit; planeoffset++;

        if(temp&0x02)highnib[planeoffset] |= shiftbit;
        if(temp&0x01)lownib[planeoffset]  |= shiftbit; planeoffset++;
        x++;                         // get the next byte
       }
    shiftbit<<=1;
    }
    // prepare the scanline for the write
    // put the accumulated nibble pairs into the write buffer
    for(i=0;i<320;i++)ptr[i] = (highnib[i]<<4)|lownib[i];

}

int grab2bmp(char *infile)
{

   // microsoft compatible bsaved format descriptor
   unsigned char bsvheader[7]={
   '\xfd','\x00','\xb8','\x00','\x00','\xA0','\x0F'};
   // thegrab self displaying com file header
   unsigned char *comheader="TheDraw COM file Screen Save";
   unsigned char buffer[4000];

   FILE *bmpfile,*fp;
   unsigned filetype;

   char *filemessage[3]={
      "File %s is not a Supported Filetype\n",
      "Now Converting Bsaved Text Screen \%s.\n",
      "Now Converting Com File \%s.\n"};

   unsigned long crtaddr;
   unsigned char vmode;
   unsigned char far *crtptr;
   unsigned char *scratch, outfile[128];
   unsigned char bmpbuffer[320];
   char *wordptr;

   int i,y;
   unsigned int j,k,c,d,x;
   unsigned temp, tempbyte, tempcolor, foreground, background;
   unsigned ctr, len = strlen(comheader);
   unsigned target=128-len;
   unsigned char *ptr;

   if((fp=fopen(infile,"rb"))==NULL)
   {
       perror(infile);
       return 1;
   }

   memset(buffer,0,4000);
   fread(buffer,128,1,fp);

   if(memcmp(buffer,bsvheader,7)==0)
    {
       filetype = BSVFILE;
       rewind(fp);
       fread(buffer,7,1,fp);
       fread(buffer,4000,1,fp);
       fclose(fp);
    }
    else
    {
       filetype=UNSUPPORTED;
       fclose(fp);
       ptr=(unsigned char *)&buffer[0];
       for(ctr=0;ctr<target;ctr++)
       {
          if(memcmp(ptr,comheader,len)==0)
           {
            // if we didn't start in mode 7 it's a CGA compatible display
            if(((_bios_equiplist() >>4) &3) <3)
            {
               vmode = 3; crtaddr = 0xb8000000L;
            }
            else
            {
               vmode = 7; crtaddr = 0xb0000000L;
             }
            crtptr = (unsigned char *)crtaddr;
            filetype = COMFILE;
            // switch to page 1
            _asm{
                 mov al, 1
                 mov ah, 5
                 int 10h
                }
            system(infile);                        // execute the com file
            for(i=0;i<4000;i++)buffer[i]=crtptr[i];
           // reset video mode
            _asm{
                 mov ah, 0
                 mov al, vmode
                 int 10h
                }
            puts("GRAB2BMP(C) Copyright by Bill Buckels 1994");
            break;                                 // break the loop
           }
            *ptr++;
        }
    }

   printf(filemessage[filetype],infile);
   if(filetype==UNSUPPORTED)return 1;

   // make a filename for our bmp file
   strcpy(bmpbuffer,infile);
   strcat(bmpbuffer,".");
   wordptr=strtok(bmpbuffer,".");
   sprintf(outfile,"%s.bmp",bmpbuffer);

   if((bmpfile=fopen(outfile,"wb"))==NULL)
   {
       perror(outfile);
       return 1;
    }

   printf("Now Creating %s.\n",outfile);
   printf("        <- Text Lines\r");

   /* write the header */
   bmpheader(bmpfile);

   // loop 25 rows
   for(i=24;i>-1;i--)
   {
    printf("\r%d",25-i);
    ptr = (unsigned char *)&buffer[i*160];
    // loop for each scanline
    for(y=15;y>-1;y--)
    {

    // loop for each bitplane
    for(j=0;j<4;j++)
    {
      // encode the current bitplane
      // 4- for each display raster
      scratch = (unsigned char *)&bmpbuffer[j*80];
      // loop 80- columns
      for(x=0;x<80;x++)               // get the next font band
      {
          c=ptr[x*2];                 // character
          d=ptr[x*2+1];               // attribute pair

          temp = d&0x0f;
          foreground = temp >> j;     // shift out the significant bit
          foreground &= 1;            // for this index

          temp = d>>4;
          background = temp >> j;
          background &= 1;

          tempbyte  = RAMFONT[c][y];
          tempcolor = 0;

          // build the bitplane pixel map from
          // the ramfont bit pattern
          for(k=0;k<8;k++)
          {
            temp = ((tempbyte>>k)&1);
            if(temp == 0)temp = background;
            else temp = foreground;
            temp <<= k;
            tempcolor |= temp;
          }
          // add the bitplane to the pixel map
          scratch[x]=tempcolor;
      }
    }

    // convert the display raster from planar line to planar nibble
    bits2nibbles(bmpbuffer);
    fwrite(bmpbuffer,320,1,bmpfile);

    // aspect ratio adjustment by default
    if(vres==475 && (y==0||y==8||y==15))fwrite(bmpbuffer,320,1,bmpfile);

    }
    }
    printf("\nDone!\n");
    fclose(bmpfile);

return 0;
}


int main(int argc,char **argv)
{
   char pathbuffer[128],drive[4],dir[67],rootname[10],ext[5];
   char filespec[81];
   struct find_t wild_card;
   int status;

   if(atoi(argv[2])==400)vres = 400;
   puts("GRAB2BMP(C) Copyright by Bill Buckels 1994");

   if(argc<2)
    {
     puts("Usage is \"GRAB2BMP [my.fil] [400 - optional aspect]\"");
     return 1;
    }

    strcpy(filespec,argv[1]);
    strcpy(pathbuffer,argv[1]);
    if(_dos_findfirst(filespec,_A_NORMAL,&wild_card)!=0)
     {
      printf("No files of type %s were found!\n",argv[1]);
      return 1;
     }
    _splitpath(pathbuffer,drive,dir,rootname,ext);

    for(;;)
    {
      sprintf(filespec,"%s%s%s",drive,dir,wild_card.name);
      if((status = grab2bmp(filespec))!=0)
      {
         printf("press any key..."); if(getch()==0)getch(); printf("\n");
      }
      if(_dos_findnext(&wild_card)!=0)break;
    }
    return 0;
}

